#pragma once

#include "ofMain.h"
#include "ofxOsc.h"
#include "RapidVisualization.hpp"
#define PORT 8338
#define NUM_MSG_STRINGS 20

class ofApp : public ofBaseApp{

public:
    void setup();
    void update();
    void draw();

    void keyPressed(int key);
    void keyReleased(int key);
    void mouseMoved(int x, int y );
    void mouseDragged(int x, int y, int button);
    void mousePressed(int x, int y, int button);
    void mouseReleased(int x, int y, int button);
    void mouseEntered(int x, int y);
    void mouseExited(int x, int y);
    void windowResized(int w, int h);
    void dragEvent(ofDragInfo dragInfo);
    void gotMessage(ofMessage msg);
		
private:
    bool guiHide = false;
    RapidVisualization rv;
    ofxOscReceiver receiver;
    int current_msg_string;
    
    std::string msg_strings[NUM_MSG_STRINGS];
    float timers[NUM_MSG_STRINGS];
};
